#include "Bparsetree.h"

// its ok if these things are global because
// they are read-only. (someday i will make them const's.)

Bastnode_t::opcode_t Bastnode_t::bogus = new Bop_t ("bogus");
Bastnode_t::opcode_t Bastnode_t::empty = new Bop_t ("empty");
Bastnode_t::opcode_t Bastnode_t::utility = new Bop_t ("utility");
Bastnode_t::opcode_t Bastnode_t::update = new Bop_t ("update");
Bastnode_t::opcode_t Bastnode_t::query = new Bop_t ("query");
Bastnode_t::opcode_t Bastnode_t::create_idx = new Bcreate_idx_op_t ("create_idx");
Bastnode_t::opcode_t Bastnode_t::create_clus_idx = new Bcreate_idx_op_t ("create_clus_idx");
Bastnode_t::opcode_t Bastnode_t::drop_idx = new Bop_t ("drop_idx");
Bastnode_t::opcode_t Bastnode_t::create_table = new Bcreate_table_op_t ("create_table");
Bastnode_t::opcode_t Bastnode_t::load_table = new Bload_table_op_t ("load_table");
Bastnode_t::opcode_t Bastnode_t::drop_table = new Bdrop_table_op_t ("drop_table");
Bastnode_t::opcode_t Bastnode_t::create_db = new Bcreate_db_op_t ("create_db");
Bastnode_t::opcode_t Bastnode_t::drop_db = new Bop_t ("drop_db");
Bastnode_t::opcode_t Bastnode_t::open_db = new Bopen_db_op_t ("open_db");
Bastnode_t::opcode_t Bastnode_t::close_db = new Bclose_db_op_t ("close_db");
Bastnode_t::opcode_t Bastnode_t::delete_stmt = new Bop_t ("delete_stmt");
Bastnode_t::opcode_t Bastnode_t::insert_values = new Bop_t ("insert_values");
Bastnode_t::opcode_t Bastnode_t::insert_query = new Bop_t ("insert_query");
Bastnode_t::opcode_t Bastnode_t::update_stmt = new Bop_t ("update_stmt");
Bastnode_t::opcode_t Bastnode_t::attr_assign = new Bop_t ("attr_assign");
Bastnode_t::opcode_t Bastnode_t::attr_null = new Bop_t ("attr_null");
Bastnode_t::opcode_t Bastnode_t::query_stmt = new Bquery_stmt_op_t ("query_stmt");
Bastnode_t::opcode_t Bastnode_t::set_xsect = new Bop_t ("set_xsect");
Bastnode_t::opcode_t Bastnode_t::set_minus = new Bop_t ("set_minus");
Bastnode_t::opcode_t Bastnode_t::set_union = new Bop_t ("set_union");
Bastnode_t::opcode_t Bastnode_t::select_star = new Bop_t ("select_star");
Bastnode_t::opcode_t Bastnode_t::select_all = new Bop_t ("select_all");
Bastnode_t::opcode_t Bastnode_t::select_dist = new Bop_t ("select_dist");
Bastnode_t::opcode_t Bastnode_t::identifier = new Bop_t ("identifier");
Bastnode_t::opcode_t Bastnode_t::rel_var = new Brel_var_op_t ("rel_var");
Bastnode_t::opcode_t Bastnode_t::rel_name = new Brel_name_op_t ("rel_name");
Bastnode_t::opcode_t Bastnode_t::predicate = new Bop_t ("predicate");
Bastnode_t::opcode_t Bastnode_t::equal = new Brelop_op_t ("equal", Acat_t::eq ());
Bastnode_t::opcode_t Bastnode_t::not_equal = new Brelop_op_t ("not_equal", Acat_t::neq ());
Bastnode_t::opcode_t Bastnode_t::less = new Brelop_op_t ("less", Acat_t::lt ());
Bastnode_t::opcode_t Bastnode_t::less_equal = new Brelop_op_t ("less_equal", Acat_t::leq ());
Bastnode_t::opcode_t Bastnode_t::greater = new Brelop_op_t ("greater", Acat_t::gt ());
Bastnode_t::opcode_t Bastnode_t::greater_equal = new Brelop_op_t ("greater_equal", Acat_t::geq ());
Bastnode_t::opcode_t Bastnode_t::overlaps = new Brelop_op_t ("overlaps", Acat_t::ovlp ());
Bastnode_t::opcode_t Bastnode_t::not_overlaps = new Brelop_op_t ("not_overlaps", Acat_t::not_ovlp ());
Bastnode_t::opcode_t Bastnode_t::oid_ref = new Boid_ref_op_t ("oid_ref");
Bastnode_t::opcode_t Bastnode_t::bool_expr = new Bbool_expr_op_t ("bool_expr");
Bastnode_t::opcode_t Bastnode_t::between = new Bbetween_op_t ("between");
Bastnode_t::opcode_t Bastnode_t::not_between = new Bbetween_op_t ("not_between");
Bastnode_t::opcode_t Bastnode_t::not = new Bop_t ("not");
Bastnode_t::opcode_t Bastnode_t::and = new Band_op_t ("and");
Bastnode_t::opcode_t Bastnode_t::or = new Bop_t ("or");
Bastnode_t::opcode_t Bastnode_t::unary_plus = new Barith_op_t ("unary_plus", "+");
Bastnode_t::opcode_t Bastnode_t::unary_minus = new Barith_op_t ("unary_minus", "-");
Bastnode_t::opcode_t Bastnode_t::plus = new Barith_op_t ("plus", "+");
Bastnode_t::opcode_t Bastnode_t::minus = new Barith_op_t ("minus", "-");
Bastnode_t::opcode_t Bastnode_t::times = new Barith_op_t ("times", "*");
Bastnode_t::opcode_t Bastnode_t::div = new Barith_op_t ("div", "/");
Bastnode_t::opcode_t Bastnode_t::literal = new Bliteral_op_t ("literal");
Bastnode_t::opcode_t Bastnode_t::reference = new Breference_op_t ("reference");
Bastnode_t::opcode_t Bastnode_t::invoke_method = new Binvoke_method_op_t ("invoke_method");
Bastnode_t::opcode_t Bastnode_t::func_call = new Bfunc_call_op_t ("func_call");
Bastnode_t::opcode_t Bastnode_t::attref = new Battref_op_t ("attref");
Bastnode_t::opcode_t Bastnode_t::relref = new Brelref_op_t ("relref");
Bastnode_t::opcode_t Bastnode_t::oid = new Boid_op_t ("oid");
Bastnode_t::opcode_t Bastnode_t::rel_oid = new Brel_oid_op_t ("rel_oid");
Bastnode_t::opcode_t Bastnode_t::integer = new Blitval_op_t ("integer");
Bastnode_t::opcode_t Bastnode_t::real = new Blitval_op_t ("float");
Bastnode_t::opcode_t Bastnode_t::string = new Blitval_op_t ("string");
Bastnode_t::opcode_t Bastnode_t::const_expr = new Bconst_expr_op_t ("const_expr");
Bastnode_t::opcode_t Bastnode_t::asc = new Bop_t ("asc");
Bastnode_t::opcode_t Bastnode_t::dsc = new Bop_t ("dsc");
Bastnode_t::opcode_t Bastnode_t::asc_idx_attref = new Bop_t ("asc_idx_attref");
Bastnode_t::opcode_t Bastnode_t::dsc_idx_attref = new Bop_t ("dsc_idx_attref");
Bastnode_t::opcode_t Bastnode_t::col_typename = new Bop_t ("col_typename");
Bastnode_t::opcode_t Bastnode_t::clustered = new Bop_t ("clustered");
Bastnode_t::opcode_t Bastnode_t::all = new Bop_t ("all");
Bastnode_t::opcode_t Bastnode_t::distinct = new Bop_t ("distinct");
Bastnode_t::opcode_t Bastnode_t::attr_update_list = new Bop_t ("attr_update_list");
Bastnode_t::opcode_t Bastnode_t::expr_list = new Bop_t ("expr_list");
Bastnode_t::opcode_t Bastnode_t::from_list = new Bfrom_list_op_t ("from_list");
Bastnode_t::opcode_t Bastnode_t::attr_or_rel_name = new Battr_or_rel_name_op_t ("attr_or_rel_name");
Bastnode_t::opcode_t Bastnode_t::arg_list = new Bop_t ("arg_list");
Bastnode_t::opcode_t Bastnode_t::groupby_list = new Bop_t ("groupby_list");
Bastnode_t::opcode_t Bastnode_t::orderby_list = new Bop_t ("orderby_list");
Bastnode_t::opcode_t Bastnode_t::set_order_by_list = new Bop_t ("set_order_by_list");
Bastnode_t::opcode_t Bastnode_t::col_list = new Bop_t ("col_list");
Bastnode_t::opcode_t Bastnode_t::col_name = new Bop_t ("col_name");
Bastnode_t::opcode_t Bastnode_t::col_number = new Bop_t ("col_number");
Bastnode_t::opcode_t Bastnode_t::filename_list = new Bop_t ("filename_list");
Bastnode_t::opcode_t Bastnode_t::filename_id = new Bop_t ("filename_id");
Bastnode_t::opcode_t Bastnode_t::filename_str = new Bop_t ("filename_str");
Bastnode_t::opcode_t Bastnode_t::idx_attr_list = new Bop_t ("idx_attr_list");
Bastnode_t::opcode_t Bastnode_t::col_typename_list = new Bop_t ("col_typename_list");
Bastnode_t::opcode_t Bastnode_t::typename = new Bop_t ("typename");
Bastnode_t::opcode_t Bastnode_t::value_list = new Bop_t ("value_list");
